;******************************************
;    Filename: PCPWM_3F_4431.asm           *
;    Date:                                *
;    File Version: 000.001                *
;    Author: PSW.RU                       *
;    Company: Labs                        *
	#include Define.h	;     
;*******************************
;    -   
;*******************************
 #ifdef	PCPWM_Present

	global	SpeedCalc,SpeedChange,StopMotor,MotorFault
	global	RevCalc;,DelayCuriosity ;   .
;	global	PDC_TableLoad;,DelayCuriosity ;   .

	Extern	InitAll,TabPwmFreq,TabDeltAngle;,Table_Sinus,Tab_SinEnd		;
	Extern	Table_Simples	;
;******************************************
PCPWM	code
 #ifdef	RestoreMainLoop
;      NOP
;       - 
	movlw	0x21	;    
 	extern	Restore_ML ; #endif ; #ifdef	RestoreMainLoop
 call	Restore_ML	; 0x21        
 #endif ; #ifdef	RestoreMainLoop
	
; SpeedCalc	;     100 
; rcall	PDC_TableLoad		;   
 #include Proj_Dir\PCPWM_3F\SpeedCalc.inc	;  -   

;SpeedChange	;   /   / PCPWM 
 #include Proj_Dir\PCPWM_3F\SpeedChange.inc	;  -   
	retlw	0x15	;  -    

RevCalc	;
 #include Proj_Dir\PCPWM_3F\Rev_Calc.inc	;  -   

 

;;********************		return	; ***********************

; call	DelayCuriosity	;	    

;

; 05/11/2021      
 #ifdef	RestoreMainLoop
Table_Sinus	code_pack	0x37FA-0x100;        
;      NOP
;       - 
	movlw	0x22	;    
 	extern	Restore_ML ; #endif ; #ifdef	RestoreMainLoop
 call	Restore_ML	; 0x22        
 #else ; #ifdef	RestoreMainLoop
Table_Sinus	code_pack	0x3800-0x100;        
 #endif ; #ifdef	RestoreMainLoop

	global	Table_Sinus,Tab_SinEnd		;
Table_Sinus	;   816    1112  
;     1/4    3   

 #ifdef	PCPWM_12b ; 12    8  -   
;	 ~2      -   
; .
;		Table_Sinus       code   0x0001f2    program   0x001b84
;       Table_Sinus       code   0x0001f2    program   0x001392
	errorlevel  -311 ; 		Message[311] 



#ifdef	PCPWM_CoSinus; Yes	;  ~2        ~10 

#ifdef	PCPWM_Dbg12b	;  12  

   #ifdef	__DEBUG		;    DeBug
; 25/01/2020   12   / 11    'Sin T_123_16'!O5:O523 .
;  	#include Proj_Dir\PCPWM_3F\Sin4_3_dW12.inc;        17%
; 25/01/2020   8+1   / 12    'Sin T_123_16'!N5:N1035 .
; 07/03/2020        .

  	;#include Proj_Dir\PCPWM_3F\Sin4_3_db9.inc;        17%
	#include Proj_Dir\PCPWM_3F\Sin4_db9.inc;   8  (0:255)    

	global	Tab_Sin3G	;  Int_PCPWM_3H_x431.inc - Interrupt.asm
Tab_Sin3G	;      128   
  	#include Proj_Dir\PCPWM_3F\Sin34_db8.inc;  8  (-127:+127)     
   #endif ;__DEBUG		;    DeBug

#else ;	PCPWM_Dbg12b	;  12  
;  	#include Proj_Dir\PCPWM_3F\CoSinTab_dW12.inc;       
; 29/12/2019   2         2      
;     -     + 17% 3 .

 #ifdef	PCPWM_3H	; 07/03/2020  
	#include Proj_Dir\PCPWM_3F\Sin4_db9.inc;   8  (0:255)    

	global	Tab_Sin3G	;  Int_PCPWM_3H_x431.inc - Interrupt.asm
Tab_Sin3G	;      128   
  	#include Proj_Dir\PCPWM_3F\Sin34_db8.inc;  8  (-127:+127)     

 #else ;#ifdef	PCPWM_3H	;    12 
  	#include Proj_Dir\PCPWM_3F\CoSin_3_dW12.inc;      17% 
 #endif;#ifdef	PCPWM_3H	;

#endif ;PCPWM_Dbg12b	;  12  

#else ; #ifdef PCPWM_CoSinus ;   -   ,    8  RC  CLC/512 .
	#include Proj_Dir\PCPWM_3F\SinTab_dW12.inc	;   .
#endif ; #ifdef PCPWM_CoSinus ;

 	errorlevel  +311 ; 	Message[311] 
 #else;	PCPWM_12b ;  8 
; 256   2  -.
  #include Proj_Dir\PCPWM_3F\SinusTable_dw_16.inc	;   -  .
 #endif ;#ifdef	PCPWM_12b ; 12    8  -   
Tab_SinEnd	;    


; 05/11/2021    " "
;          
;   +  
	global	EPROM_FData,EPROM_FData_End
EPROM_FData	; Factory Data copy
 #ifdef FactoryDefaultsValue;	macro	;   
	FactoryDefaultsValue;	macro	;    
 #else	;#ifdef FactoryDefaultsValue;	  
;#else ;       - , , 
;    EPROM\EPROM_Data.inc
;  PCPWM_3F\Parameters_PSW_12b.xls/Param:N4:N35
  db 0x0C ;   0-15=PCPWM_MotorNum
  db 0x5 ;4  =LCD_DebounceTimeOut
;	db	d'53';0x22;09 LCD_6_4	;    4   6
  db d'1';0x53 ;  4 =LCD_6_4

;  09/06/2020       
  db 0x70; PCPWM_SpdMin;  )     
  db 0x28; PCPWM_SpdDelta )       
  db 0x81; PCPWM_K_Prop	  )    
  db 0x82; PCPWM_K_Integr )    
  db 0x83; PCPWM_K_Diff	  )    
  db 0x10; PCPWM_Alrm_Tim )      
  db 0x00; Adc_Corr+5;	  ) AN   
  db 0x26; Adc_Corr+4;	  ) AN   

  db 0x81; 0x05 ;    =Adc_Corr+3
  db d'12' ;  =Adc_Corr+2
  db d'13';0x09 ;   =Adc_Corr+1
  db d'41';-d'9' ;0xAB ; -085  =Adc_Corr+0
;*****************************   
;  db 0x70 ; 60 ;   (  )=Par_UV ;    
;***************************** 
  db 0xC9 ;  =Par_V
  db 0x10 ; 1D ; Par_VS; 10=  /
  db 0xA6 ;   =Par_T
	#ifdef	W1_Pin
  db 0x70 ; W1 Temp=Par_K
  db 0x65 ; W1 temp1=Par_K1
	#endif ;#ifdef	W1_Pin

  db 0x10 ;  DC =PcDC_Kf
 ; db 0x8A ;   DC =PcDC_VN

  db 0x0A ;     =PcPwmTopDT
  db 0x18 ; DTCON 0-63  =DTCON
  db 0x01 ; Delay Curiosity=DelayCuriosityIndex
;    
;#endif ;#ifdef PCPWM_Board ;       

;    0   
  db 0x07 ;  =PCPWM_Speed
  db 0xbb ; V/F Amp=PCPWM_Amp
  db 0x46 ; V/F Start=PCPWM_VFStart
  db 0x27 ; Accelerate=PCPWM_Accelerate
  db 0x48 ; =Par_A
  db 0x00 ;   =PCPWM_MaxSpdIndx
  db 0x0A ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x75 ;   -127:127=PCPWM_AutoStart
  db 0x01 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x20 ;    1=PCPWM_Speed_M0
  db 0x30 ;    2=PCPWM_Speed_M1
;;      :
;;	db	d'00';0x10;10 PCPWM_MaxSpdIndx; 0=100  ,      .
;;	db	0xBB;01 PCPWM_Amp
;;	db	0x46;02 PCPWM_VFStart
;;	db	0x1;07 DelayCuriosityIndex
;;	db	0x27;03 PCPWM_Accelerate    .
;;   07 Over Current = 78 -     /  
;;        - .

;;;      400  2.2  220  :
;;	db	d'03';0x10;10 PCPWM_MaxSpdIndx; 3=800  ,   400 .
;;	db	0x93;01 PCPWM_Amp -  ,      18-24
;;	db	0x06;02 PCPWM_VFStart -   -     .
;;	db	0x1;07 DelayCuriosityIndex
;;	db	0xFF;03 PCPWM_Accelerate    .
;;;   07 Over Current = F8;

;    1   
;     - 1.5  4  220/380  .
;  ~30 ,  ~ 3 .
  db 0xFF ;  =PCPWM_Speed
  db 0x80 ; V/F Amp=PCPWM_Amp
  db 0x54 ; V/F Start=PCPWM_VFStart
  db 0xFF ; Accelerate=PCPWM_Accelerate
  db 0x0E ; =Par_A
  db 0x04 ;   =PCPWM_MaxSpdIndx
  db 0x00 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x00 ;   -127:127=PCPWM_AutoStart
  db 0x01 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x80 ;    1=PCPWM_Speed_M0
  db 0x40 ;    2=PCPWM_Speed_M1


;    2   
;;;   450  2.2  220  :
;;	db	d'106';=450  PCPWM_MaxSpdIndx; 106.=0x6A=450  ,   225 .
;;	db	0xB3;01 PCPWM_Amp -  ,      18-24
;;	db	0x0A;02 PCPWM_VFStart -   -     .
;;	db	0x1;07 DelayCuriosityIndex
;;	db	0xFF;03 PCPWM_Accelerate    .
;;;   07 Over Current = 0x50; 

  db 0x55 ;  CPWM_Speed
  db 0xB3 ; V/F Amp=PCPWM_Amp
  db 0x0A ; V/F Start=PCPWM_VFStart
  db 0xF2 ; Accelerate=PCPWM_Accelerate
  db 0x52 ; =Par_A
  db 0x6A ;   =PCPWM_MaxSpdIndx
  db 0x0A ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x40 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x52 ;    1=PCPWM_Speed_M0
  db 0xA2 ;    2=PCPWM_Speed_M1


;    3   
;;;     1.5  4  220  ,      : 
;;	db	0x10;=70 ; d'00';04 PCPWM_MaxSpdIndx; 0=100  ,      .
;;	db	0xB0;05 PCPWM_Amp
;;	db	0x27;06 PCPWM_VFStart
;;	db	0x1;07 DelayCuriosityIndex
;;	db	0x40;08 PCPWM_Accelerate    .
;;;    4  1.5  


  db 0x33 ;  =PCPWM_Speed
  db 0xB0 ; V/F Amp=PCPWM_Amp
  db 0x27 ; V/F Start=PCPWM_VFStart
  db 0x93 ; Accelerate=PCPWM_Accelerate
  db 0x53 ; =Par_A
  db 0x10 ;   =PCPWM_MaxSpdIndx
  db 0x00 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x99 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x77 ;    1=PCPWM_Speed_M0
  db 0xAA ;    2=PCPWM_Speed_M1


;    4   
;;;     -1025 250  200  36  2    30  DC
;;	db	d'106';=450 ; ;04 PCPWM_MaxSpdIndx; 0=100  ,      .
;;	db	0xB0;05 PCPWM_Amp
;;	db	0x27;06 PCPWM_VFStart
;;	db	0x1;07 DelayCuriosityIndex
;;	db	0xFF;08 PCPWM_Accelerate    .

  db 0x44 ;  =PCPWM_Speed
  db 0xB0 ; V/F Amp=PCPWM_Amp
  db 0x27 ; V/F Start=PCPWM_VFStart
  db 0xF4 ; Accelerate=PCPWM_Accelerate
  db 0x54 ; =Par_A
  db 0x6A ; = ~400 Hz   =PCPWM_MaxSpdIndx
  db 0x0B ; = ~6 KHz   0-20=PcPwmFrqInd 
  db 0x03 ; =1/3 Rev    0-3=PcPwmAngInd
  db 0x04 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x0A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x77 ;    1=PCPWM_Speed_M0
  db 0xBB ;    2=PCPWM_Speed_M1

;    5   
;  -6   4100L43 4  4  50  
;   3    ,   
  db 0xFF ;  =PCPWM_Speed
  db 0x8B ; V/F Amp=PCPWM_Amp
  db 0x43 ; V/F Start=PCPWM_VFStart
  db 0x81 ; Accelerate=PCPWM_Accelerate
  db 0x77 ; =Par_A
  db 0x0C ; = ~ 65 Hz   =PCPWM_MaxSpdIndx
  db 0x00 ; = ~ 1.5 KHz   0-20=PcPwmFrqInd
  db 0x03 ; = 1/3 Rev    0-3=PcPwmAngInd
  db d'200';   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0xA2 ;   DC =PcDC_VN
  db 0x87 ; 60 ;   (  )=Par_UV ;    
  db 0x88 ;    5  1=PCPWM_Speed_M0
  db 0xAA ;    8  2=PCPWM_Speed_M1

;    6   
;"3Kw 75Hz -1 "	,0;6
  db 0x66 ;  =PCPWM_Speed
  db 0x8D ; V/F Amp=PCPWM_Amp
  db 0x3F ; V/F Start=PCPWM_VFStart
  db 0x5D ; Accelerate=PCPWM_Accelerate
  db 0x81 ; =Par_A
  db 0x0B ; ~ 75 Hz   =PCPWM_MaxSpdIndx
  db 0x00 ; ~ 1.5 KHz   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0xC0 ;   -127:127=PCPWM_AutoStart
  db 0x02 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x8E ; 60 ;   (  )=Par_UV ;    
  db 0x66 ;    1=PCPWM_Speed_M0
  db 0xBB ;    2=PCPWM_Speed_M1

;    7   
  db 0x07 ;  =PCPWM_Speed
  db 0x07 ; V/F Amp=PCPWM_Amp
  db 0x07 ; V/F Start=PCPWM_VFStart
  db 0xF7 ; Accelerate=PCPWM_Accelerate
  db 0x57 ; =Par_A
  db 0x00 ;   =PCPWM_MaxSpdIndx
  db 0x07 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x07 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x2A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x07 ;    1=PCPWM_Speed_M0
  db 0x07 ;    2=PCPWM_Speed_M1

;    8   
  db 0x08 ;  =PCPWM_Speed
  db 0x08 ; V/F Amp=PCPWM_Amp
  db 0x08 ; V/F Start=PCPWM_VFStart
  db 0xF8 ; Accelerate=PCPWM_Accelerate
  db 0x58 ; =Par_A
  db 0x00 ;   =PCPWM_MaxSpdIndx
  db 0x08 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x08 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x2A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x08 ;    1=PCPWM_Speed_M0
  db 0x08 ;    2=PCPWM_Speed_M1

;    9   
  db 0x09 ;  =PCPWM_Speed
  db 0x09 ; V/F Amp=PCPWM_Amp
  db 0x09 ; V/F Start=PCPWM_VFStart
  db 0xF9 ; Accelerate=PCPWM_Accelerate
  db 0x59 ; =Par_A
  db 0x00 ;   =PCPWM_MaxSpdIndx
  db 0x09 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x09 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x09 ;    1=PCPWM_Speed_M0
  db 0x09 ;    2=PCPWM_Speed_M1

;    10   
  db 0x10 ;  =PCPWM_Speed
  db 0x10 ; V/F Amp=PCPWM_Amp
  db 0x10 ; V/F Start=PCPWM_VFStart
  db 0xE0 ; Accelerate=PCPWM_Accelerate
  db 0x60 ; =Par_A
  db 0x00 ;   =PCPWM_MaxSpdIndx
  db 0x0A ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x10 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x10 ;    1=PCPWM_Speed_M0
  db 0x10 ;    2=PCPWM_Speed_M1

;    11   
  db 0x11 ;  =PCPWM_Speed
  db 0x11 ; V/F Amp=PCPWM_Amp
  db 0x11 ; V/F Start=PCPWM_VFStart
  db 0xE1 ; Accelerate=PCPWM_Accelerate
  db 0x61 ; =Par_A
  db 0x00 ;   =PCPWM_MaxSpdIndx
  db 0x0B ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x11 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x11 ;    1=PCPWM_Speed_M0
  db 0x11 ;    2=PCPWM_Speed_M1

;    12   
; 02/11/2021 - -82012 3*36V 1065W 20A 48.6 c-1 1986 .
  db 0x17 ;  =PCPWM_Speed
  db 0x82 ; V/F Amp=PCPWM_Amp
  db 0x70 ; V/F Start=PCPWM_VFStart
  db 0xFF ; Accelerate=PCPWM_Accelerate
  db 0x99 ; =Par_A
  db 0x08 ;   =PCPWM_MaxSpdIndx
  db 0x05 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x21 ;   -127:127=PCPWM_AutoStart
  db 0x02 ;    =PcPwmProg
  db 0x14 ;   DC =PcDC_VN
  db 0x07 ; 60 ;   (  )=Par_UV ;    
  db 0x33 ;    1=PCPWM_Speed_M0
  db 0x55 ;    2=PCPWM_Speed_M1

;    13 -  HDD  15  
  db 0x02 ;  =PCPWM_Speed
  db 0x3C ; V/F Amp=PCPWM_Amp
  db 0x6F ; V/F Start=PCPWM_VFStart
  db 0xFF ; Accelerate=PCPWM_Accelerate
  db 0x0B ; =Par_A
  db 0x01 ;   =PCPWM_MaxSpdIndx
  db 0x0E ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x08 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x06 ;   DC =PcDC_VN
  db 0x05 ; 60 ;   (  )=Par_UV ;    
  db 0x23 ;    1=PCPWM_Speed_M0
  db 0x83 ;    2=PCPWM_Speed_M1

;   14  - -1025    0-30  
  db 0x63 ;  =PCPWM_Speed
  db 0x9D ; V/F Amp=PCPWM_Amp
  db 0x35 ; V/F Start=PCPWM_VFStart
  db 0xFF ; Accelerate=PCPWM_Accelerate
  db 0x2A ; =Par_A
  db 0x24 ;   =PCPWM_MaxSpdIndx
  db 0x09 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x04 ;   -127:127=PCPWM_AutoStart
  db 0x01 ;    =PcPwmProg
  db 0x10 ;   DC =PcDC_VN
  db 0x07 ; 60 ;   (  )=Par_UV ;    
  db 0x28 ;    1=PCPWM_Speed_M0
  db 0x14 ;    2=PCPWM_Speed_M1

;    15  __dbbug
; 02/11/2021 - -82012 3*36V 1065W 20A 48.6 c-1 1986 .
  db 0x05 ;  =PCPWM_Speed
  db 0xEE ; V/F Amp=PCPWM_Amp
  db 0xE6 ; V/F Start=PCPWM_VFStart
  db 0x33 ; Accelerate=PCPWM_Accelerate
  db 0x99 ; =Par_A
  db 0x04 ;   =PCPWM_MaxSpdIndx
  db 0x00 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x03 ;   -127:127=PCPWM_AutoStart
  db 0x01 ;    =PcPwmProg
  db 0x15 ;   DC =PcDC_VN
  db 0x07 ; 60 ;   (  )=Par_UV ;    
  db 0x88 ;    1=PCPWM_Speed_M0
  db 0x66 ;    2=PCPWM_Speed_M1

 #endif	;#ifdef FactoryDefaultsValue;	macro

;;   256  -    
EPROM_FData_End

 #if (EPROM_FData_End-EPROM_FData) != 0x100 ;     
  messg "Size Factory Default Block NOT equal 256 bytes" 
 #endif


;******************************************************************************

  
;;*******************************
;    -   
;*******************************
 #endif ;ifdef	PCPWM_Present
;End of program
		END
