; ********** GENERATED Common Main Loop Task File Created 15.11.2021 17:35:14,67 
; *******************  Begin File Main\MLTask_Main.inc ***************** 

;	*** main code goes here ***
;	movf	TMR1L,W,ACCESS	;	clrwdt

; #endif
 ; *******************  Begin File EPROM\MLTask_EPROM.inc ***************** 
;*********************   	  *******************************

 extern	EPROM_Sync
;	EPROM_Page; BSR for EPROM Task  EePROM_Sync
 #ifdef	LCD_Present
	btfsc	LCD_Flg1,0,ACCESS	;    ?
		call	EPROM_Sync	;  -     
 #endif
; *******************  Begin File RTK\MLTask_RTK.inc ***************** 
 extern	TK_10,TK_100,TK_1000;    


 #ifdef	DelayCuriosityTest	; 07/03/2020   
 	#ifdef ADC_Present
	ADC_Page	; BSR for ADC Task
	Inc24	ADC_Cnt_All,BANKED	;  
 	#endif	; #ifdef ADC_Present
 #endif ;#ifdef	DelayCuriosityTest	; 07/03/2020   


;************ Time keeping **********************
;         - 
;    1000,100  10     
;   -    
;     100  1000  (18750       100  1000)
;  10      -    (   ).
	btfss	TaskFlag1,6,ACCESS		;  1000      ?
		bra	DoneTK_1000
	bcf	TaskFlag1,6,ACCESS		;  1000   
		RTK_Page	;
	call	TK_1000		;	   1000 
;	movwf	StatusRTK_1000
DoneTK_1000

	btfss	TaskFlag1,5,ACCESS		;  100      ?
		bra	DoneTK_100
	bcf	TaskFlag1,5,ACCESS		;  100  
		RTK_Page	;
	call	TK_100		;	   100 
;	movwf	StatusRTK_100
DoneTK_100

	btfss	TaskFlag1,0,ACCESS		;  10      ?
		bra	DoneTK_10
		RTK_Page	;
	bcf	TaskFlag1,0,ACCESS		;  10      ?
	call	TK_10		;	   10 
;	movwf	StatusRTK_10
DoneTK_10
; *******************  Begin File 1W\MLTask_1W.inc ***************** 
;************* 1-Wire  *********************
;	W1_Page	; movlb	0x0					; BSR  0 
	btfss	W_1_Flg,0,ACCESS		;  1-Wire   ?
		bra	W1_Task_Done
	W1_Page	; movlb	0x0	; BSR  0  StepTask
	bcf	W_1_Flg,5,ACCESS;5=       -   

;   
	movlf	MaxW1Pointer,W1_Temp,BANKED; - GoToWreg,BANKED	;    
	movf	W1_Route,W,BANKED	;
	;bz		DoneW1_Task		;   -   "" 1-Wire
	cpfsgt	W1_Temp,BANKED			; (f) - (WREG) skip if (f) > (WREG); (unsigned comparison)
		clrf	W1_Route,BANKED	;    
;;		retlw	0x0	;bra		DoneW1_Task		;    -  
  extern	W1_Task	;   	
	call	W1_Task	;	      

;;   -     12/07/2021 08:00
;	extern	Address_Table	;
;	movlf16	Address_Table,TBLPTRL,ACCESS	;   
;;	movlf16	W1_Task_Return,PRODL,ACCESS		;  
;	movf	W1_Route,W,BANKED	;    
;;	movlw	d'44'	;	     =    
; 	rcall	GoToTab			;      WREG
;;W1_Task_Return
;	movwf	PRODL,ACCESS	;  
;
;;	bra		DoneW1_Task		;   -    
;
W1_Task_Done; *******************  Begin File LCD_Key_Enc\MLTask_LCD_Key_Enc.inc ***************** 
;	extern	LCD_Task,Task_Keys,Task_KeyBoardInput,Encoder

;********************** LCD 44780  , ,   *******************
 ;LCD_BANK	;    	
 ;DefaultBankSelect

	btfss	LCD_Flg,4,ACCESS	;  LCD    ?
;		bra	LCD_Done1
;	LCD_BANK	;    	
		extern	LCD_Task
	call	LCD_Task	;  -    .
;LCD_Done1
;************ Encoder Task **********************
 ;LCD_BANK	;    
	;DefaultBankSelect
	;movlb	0x0					; BSR  1  StepTask
	btfss	TaskFlag1,1,ACCESS		;  PortB    PortB ?
		bra	LCD_Done2; 
		LCD_BANK	;    
	bcf		TaskFlag1,1,ACCESS		;  PortB   
		extern	Task_Keys
		call	Task_Keys		;	  
LCD_Done2; 
 ;************           **********************
 ;LCD_BANK	;    
	;DefaultBankSelect
	;movlb	0x0					; BSR  1  StepTask
	btfsc	TaskFlag1,2,ACCESS	;  KeyRead    100  ?
	btfss	LCD_Flg,4,ACCESS	;  LCD    ?
			bra	LCD_Done3;           
 	LCD_BusDisable	;bcf LCD_E	; 1=  LCD
	LCD_BANK	;    
		extern	KeyboardRead
		call KeyboardRead	;     
LCD_Done3

	btfss	TaskFlag1,3,ACCESS		;  Encoder      ?
			bra	LCD_Done4;
		LCD_BANK	;    
	bcf		TaskFlag1,3,ACCESS		;  Encoder   
		extern	Encoder
		call	Encoder		;	  
LCD_Done4;
; *******************  Begin File Beeper\MLTask_Beeper.inc ***************** 
;		Beeper_Page	;
;	movlw	0x20
	
	;	dcfsnz	DeBug_Beeper,F,BANKED
	;	Beeper_Toggle	;
; *******************  Begin File PCPWM_3F\MLTask_PCPWM_3F.inc ***************** 
;************ PCPWM_Task **********************
 		PCPWM_Page	;
 Extern	StopMotor	;
;      12 
;	btfsc	PCPWM_Flag,0,ACCESS	;  PCPWM  ?
;		call	PCPWM_Task ;   .
;      18750 
	btfss	PCPWM_Flag,1,ACCESS	; 1/100   ?
		bra	DoneSpeedCalc
	; PCPWM_Page	; BSR for PCPWM Task
	bcf	PCPWM_Flag,1,ACCESS	;  ,    
 Extern	SpeedCalc			;
		call	SpeedCalc ;   .
	;	dcfsnz	DeBug_Beeper,F,BANKED
	;	Beeper_Toggle	;
DoneSpeedCalc

;      9 375/XX 
	btfss	PCPWM_Flag,5,ACCESS	; 1/XX   ?
		bra	DoneSpeedChange

	;	PCPWM_Page	; BSR for PCPWM Task
	bcf PCPWM_Flag,5,ACCESS	;;5=     9 375  ,   
 	movff	PCPWM_Accelerate,PCPWM_AccelCounter;     
	movf	PcPwmProg,W,BANKED	;,F,BANKED;10=   
	 bnz		PcPwmProg_1 ;  
; =========   0 ===============
 Extern	SpeedChange		;
	call	SpeedChange ;  0 =  = 0 =      .
     bra	SaveMotorStatus

; =========   1 ===============
PcPwmProg_1
	decfsz	WREG,W,ACCESS
		bra		PcPwmProg_2
 Extern	SpeedChange1	 ;
	call	SpeedChange1 ; 1 =  = 1 .
	bra	SaveMotorStatus

; =========   2 ===============
PcPwmProg_2
	decfsz	WREG,W,ACCESS
		bra		PcPwmProg_3
 Extern	SpeedChange2	 ;
	call	SpeedChange2 ; 2 =  = 2 .
	bra	SaveMotorStatus

; =========   >2 ===============
PcPwmProg_3
 Extern	SpeedChange3
	call	SpeedChange3 ; >2  = 3 .
SaveMotorStatus
	movwf	PCPWM_MotorStatus,BANKED ;
;	bra	DoneSpeedChange
;
DoneSpeedChange
	btfss	PCPWM_Flag,7,ACCESS	;   ?
		bra	DoneRevCalc
	
	;PCPWM_Page	; BSR for PCPWM Task
 Extern	RevCalc ; DelayCuriosity,  
		call	RevCalc ;   .

DoneRevCalc

;	btfss	RevCalc_Flag,3,BANKED;;3=      ; -1     
;		bra	DonePwmPulse
;	bcf		RevCalc_Flag,3,BANKED;; 3=      ; -1     	
;	bcf	PIE1,ADIE,ACCESS ;   
;	BCF INTCON, GIE,ACCESS; Disable Interrupts High/All
;DonePwmPulse


	;	dcfsnz	DeBug_Beeper,F,BANKED
	;	Beeper_Toggle	;
; call	DelayCuriosity	;	   
 ; *******************  Begin File ADC\MLTask_ADC.inc ***************** 
 extern ADC_Task				;
	btfsc	ADC_Flag,0,ACCESS	;
		call	ADC_Task		;
