;   Define.h  ~49
; #include Proj_Dir\Cfg\V3_Cfg1.inc	;       
;      2.03,    LCD = R/W ,
;     .


;   -  BulkErase    
; #define NotEpromParamProg		No	;      \EPROM\EPROM_Data.inc 

;   Define_PCPWM_3F.inc

;  3  2 ;
 #define SetTermistorOutput		bcf TRISA,0,ACCESS	;   
 #define SetTermistorInput		bsf TRISA,0,ACCESS	;   


;   Table_1W.inc
SN_Ds18B20	macro	;   
 db	d'0',d'3'	;     
	db	0x28,0x52,0xE4,0x00,0x00,0x00,0x00,0x9B	;   6
	db	0x28,0x52,0xE4,0x00,0x00,0x00,0x00,0x9B	;   6
	db	0x28,0x52,0xE4,0x00,0x00,0x00,0x00,0x9B	;   6
;	db	0x28,0x4C,0x70,0x39,0x01,0x00,0x00,0x0B	;   0724C3-422AE    
	endm			;

WorkScreens	macro	;  LCD_Text_FA.inc
;*******     0 ********  ******
Msg7	;     10   ,   .
 db	d'39',HexUByte1ch	;     
	dw	Tic_10;       3  

 db SendByte2CmdReg,d'72',DecSWordTemp6ch;
  	dw	Adc_Volt+2				;  IRAMX
 db SendByte2CmdReg,d'71',"T="	;    ?

 #ifdef	PCPWM_12b;	 Yes	; 12    8  -   
	db SendByte2CmdReg,d'19' ;   
 	db HexUWord4ch;;   Hex - 4 
 #else ;#ifdef	PCPWM_12b;
	db SendByte2CmdReg,d'20' ;   
 	db HexUByte2ch;   Hex - 2 
 #endif ;#ifdef	PCPWM_12b;
	dw PCPWM_AmpSin ;   

	db	DecSWordTemp6ch	;
   dw	Adc_Volt+0		;  0
 	db "V"				;

 db SendByte2CmdReg,d'84' ; ******  *****  
 db SubStringOut,0	; 4    + 
    dw LCD_4_Buf;,F,BANKED;    4 

 #ifdef	W1_Pin ; ******  *****  
  db SendByte2CmdReg,d'78',DecSWordTemp6ch		;,
 dw DS1820_ScratctPad1+0	;     
  db SendByte2CmdReg,d'64',DecSWordTemp6ch		;,
 dw DS1820_ScratctPad1+2 ;   ,0x19,DS1820_ScratctPad1+4 ;,0; 10 byte
  db "," 					;
 #endif ; #ifdef	W1_Pin

  db SendByte2CmdReg,d'7',SubStringOut,0	; + 
 dw PCPWM_AnimeSubStr	;;   
  db SubStringOut,0		; + 
 dw PCPWM_ForwardReverse;

 	db 0 ;  

Msg8;  ******   1 ******   *********

 db	d'39',HexUByte1ch	;     
	dw	Tic_10;       3  

 db SendByte2CmdReg,d'00',"  ="
 db ParamRegulate,0x31,0xFF, HexUByte2ch ;
  dw	PCPWM_Accelerate ;,F,BANKED;   
 db " "			;


 db SendByte2CmdReg,d'72',DecSWordTemp6ch;
  	dw	Adc_Volt+2				;  IRAMX
 db SendByte2CmdReg,d'71',"T="	;    ?

		db SendByte2CmdReg,d'84' ;   
;    SubStringOut 
 db SubStringOut,0	; 4    + 
    dw LCD_4_Buf;,F,BANKED;    4 

 #ifdef	W1_Pin
  db SendByte2CmdReg,d'78',DecSWordTemp6ch		;,
 dw DS1820_ScratctPad1+0	;     
  db SendByte2CmdReg,d'64',DecSWordTemp6ch		;,
 dw DS1820_ScratctPad1+2 ;   ,0x19,DS1820_ScratctPad1+4 ;,0; 10 byte
  db "," 					;
 #endif ; #ifdef	W1_Pin
 
 	db 0 ;  

;******     2 ********" =" ************
Msg9	;     10   ,   2.
 db	d'39',HexUByte1ch	;   
	dw	Tic_10;       3  

 db SendByte2CmdReg,Beg_1_Str+d'00',"=",HexUByte2ch;; ="
	dw	I_DC+1;Adc_AmpPeak	;   ;   
 db	 ", ="	;,
 db ParamRegulate,0x21,0xFF, HexUByte2ch ;
  dw	Par_A ;,F,BANKED;   
 db " "			;

 db SendByte2CmdReg,Beg_3_Str+d'00',"M=",HexUByte2ch;
	dw	Par_OC;I_DC+1;Adc_AmpPeak	;  ;   ;   
 db ", =",HexUByte2ch;
	dw	OC_RevCnt;I_DC+1;Adc_AmpPeak;   


 db SendByte2CmdReg,d'72',DecSWordTemp6ch;
  	dw	Adc_Volt+2				;  IRAMX
 db SendByte2CmdReg,d'71',"T="	;    ?

		db SendByte2CmdReg,Beg_4_Str+d'00' ;   
;    SubStringOut 
 db SubStringOut,0	; 4    + 
    dw LCD_4_Buf;,F,BANKED;    4 

 #ifdef	W1_Pin
  db SendByte2CmdReg,Beg_2_Str+d'14',DecSWordTemp6ch		;,
 dw DS1820_ScratctPad1+0	;     
  db SendByte2CmdReg,Beg_2_Str+d'00',DecSWordTemp6ch		;,
 dw DS1820_ScratctPad1+2 ;   ,0x19,DS1820_ScratctPad1+4 ;,0; 10 byte
  db "," 					;
 #endif ; #ifdef	W1_Pin
 
 	db 0 ;  
	endm

;   Define_1W.inc
;   1-
;; #else			;2431  2
#define W1_TRIS			TRISC
#define W1_Lat			LATC
#define W1_Port			PORTC
#define W1_Pin			7	; RC7 = 1Ware ; 18  2431
; #endif
;
#define W1_Clear		bcf	W1_Lat,W1_Pin,ACCESS
#define W1_Set			bsf	W1_Lat,W1_Pin,ACCESS
#define W1_Output		bcf	W1_TRIS,W1_Pin,ACCESS
#define W1_Input		bsf	W1_TRIS,W1_Pin,ACCESS

; ;   Define_Beeper.inc
;   Beeper
; Pin and port:
;#else			;2431
;  2
 #define Beeper_TRIS	TRISC
 #define Beeper_Lat		LATC
 #define Beeper_Port	PORTC
 #define Beeper_Pin		6	; RC6 = Beeper ; 17  2431

#define BeeperPin	 	Beeper_Lat,Beeper_Pin,ACCESS
;#define BeeperOutPut 	bsf	Beeper_TRIS,Beeper_Pin,ACCESS
; Macros for sound:
#define Beeper_Output	bcf	Beeper_TRIS,Beeper_Pin,ACCESS
;#define Beeper_Input		bsf	Beeper_TRIS,Beeper_Pin,ACCESS
;#define Beeper_Clear		bcf	BeeperPin
;#define Beeper_Set		bsf	BeeperPin
#define Beeper_Toggle	btg	BeeperPin
#define Beeper_TrisTogl	btg	Beeper_TRIS,Beeper_Pin,ACCESS

;        -  
;  3
;
;  2
 #define Fault_TempMon	ADC_Out+0	;N0 =  2 = 
 #define I_DC			ADC_Out+4	;N2 =  4 =    DC 
 #define U_DC			ADC_Out+6	;N3 =  5 =   DC 
 #define SensorInput 	ADC_Out+2	;N1 =  3 =  /  QEA

;     .
 #define I_DC_Zero	d'8000' ;d'2621' ; 0xFFFF/25	; ~1/25=0.2V        

;      -      .
;   ADC_Step.inc  ~151
; FXM0808SL	Adc_Corr+2,bnk,d'13';     ""
; Add16L PRODL,acs,0x1eff*0x8;   495=0x1ef   F 
; FXM1616U2 ADC_Work+0,bnk	,ADC_Out+4,bnk	,PRODL,acs,	ADC_Work+7,bnk;
; RShift16_N	ADC_Work+2,bnk,3	; 3   2 
; movff_N ADC_Work+2,Adc_Volt+2,2;   -    

 #define I_DC_RevCnt	d'3' ;	;      
 #define I_DC_MulCorr	d'61' ;	;     ""
;  ""   ,   
;      .

;  30,  ~9.6 ,    1/2,    1/2,
;   ~10 , 5 , 32*16  :
;    1/4    ,     
;     50,    ~ 30 
; I_DC_AddCorr       -    .
 #define I_DC_AddCorr	d'16522' ; d'26767' ; d'42921'; =512*5/0.096   5/0,096     512
 #define I_DC_ShiftCorr 5; RShift16_N ADC_Work+2,bnk,5	; 1   2  -  7  2  -   ,   .
 #define AnSens_SubZero	d'13107';   .  1  = 65536/5 = 13107
 #define AnSens_MulZero	d'13';     ""
 #define AnSens_MulCorr	d'43';     ""
 #define AnSens_AddCorr	d'49555';         
 #define AnSens_ShiftCorr 5	; 21    = 16 ( 2 ) + 5  2  

;   -      
 #define Key_Up			PortB_Buf,2,ACCESS	;  ++
 #define Key_Down		PortB_Buf,1,ACCESS	;   ++
 #define Key_Left		PortB_Buf,3,ACCESS	;   ++ 
 #define Key_Right		PortB_Buf,4,ACCESS	;  ++
 #define Key_E_Up		PortB_Buf,7,ACCESS	; .   ++
 #define Key_E_Down		PortB_Buf,6,ACCESS	; .    
 #define Key_Encoder	PortB_Buf,5,ACCESS ;  	++
 #define Key_EncMask	andlw	b'00100000';     ++

 #define Encoder_B0	Encoder_Bits,6,BANKED ; 0 
 #define Encoder_B1	Encoder_Bits,7,BANKED ; 1 

;  SpeedChange_2    :
#define DoubleFreqKey	Key_Right	; PortB_Buf,4,ACCESS	; 
#define HalfFreqKey	 	Key_Left	; PortB_Buf,3,ACCESS	; 
#define Mem_0_Key		Key_Up		; PortB_Buf,1,ACCESS	;   
#define Mem_1_Key		Key_Down	; PortB_Buf,2,ACCESS	;  
#define RevRunKey	Key_E_Down		; Encoder_Buf,7,BANKED;PortB_Buf,7,ACCESS	;   7F 
#define ForwRunKey	Key_E_Up		; Encoder_Buf,6,BANKED;PortB_Buf,6,ACCESS;    BF 

;  SpeedChange_3     -:
;#define RevRunKey	Encoder_Buf,7,BANKED;PortB_Buf,7,ACCESS	;   7F 
;#define ForwRunKey	Encoder_Buf,6,BANKED;PortB_Buf,6,ACCESS;    BF 

 #define StartTimDefLd d'50';0x50	;      


EncoderBitsInput	Macro	;      -    
;  3
; movb	LCD_Key_Port0,	Encoder_Bits,7,BANKED ; Encoder_B1; 
; movb	LCD_Key_Port2,	Encoder_Bits,6,BANKED ; Encoder_B0; 

;    2
; 14/01/2020   Encoder_Bits
	movb	LCD_Key_Port2,Encoder_Bits,7,BANKED ; 
	movb	LCD_Key_Port0,Encoder_Bits,6,BANKED ; 
	endm

KeysRow1Input	Macro	;  1     
;  3
; movb	LCD_Key_Port2,	PortB_Buf,7,ACCESS ; Key_E_Down	; 
; movb	LCD_Key_Port0,	PortB_Buf,6,ACCESS ; Key_E_Up	; 
; movb	LCD_Key_Port1,	PortB_Buf,4,ACCESS ; Key_Left	;   -  

;    2
	movb	LCD_Key_Port3,PortB_Buf,4,ACCESS ; 
;	movb	LCD_Key_Port2,PortB_Buf,2,ACCESS ; 
	movb	LCD_Key_Port1,PortB_Buf,5,ACCESS ; 
;	movb	LCD_Key_Port1,PortB_Buf,0,ACCESS ; 
	LCD_KeyInp
;***	bsf		LATA,6,ACCESS	;  10 	
	movbi	LCD_InKey,PortB_Buf,7,ACCESS ;  

	endm

KeysRow2Input	Macro	;  3   -    .
;  2
 movb	LCD_Key_Port3,PortB_Buf,3,ACCESS ;     
 movb	LCD_Key_Port2,PortB_Buf,2,ACCESS ; Key_Down	;   
 movb	LCD_Key_Port1,PortB_Buf,1,ACCESS ; Key_Right	; 
 movb	LCD_Key_Port0,PortB_Buf,0,ACCESS ; Key_Up		;   

	movbi	LCD_InKey,PortB_Buf,6,ACCESS ;  
	endm

#define LED0_Pin 		6
	#ifdef	LED0_Pin
#define LED0_PORT 		LATB
#define LED0_TRIS 		TRISB
#define Debug_LED0		LED0_PORT,LED0_Pin,ACCESS
#define LED0_Output	bcf	LED0_TRIS,LED0_Pin,ACCESS
#define LED0_Set	bcf	Debug_LED0	;   +5 
#define LED0_Clear	bsf	Debug_LED0	; 
#define LED0_Toggle	btg	Debug_LED0
	#else
#define LED0_Output	nop
#define LED0_Set	nop
#define LED0_Clear	nop
#define LED0_Toggle	nop
	#endif


#define LED1_Pin 		7
	#ifdef	LED1_Pin
#define LED1_PORT 		LATB
#define LED1_TRIS 		TRISB
#define Debug_LED1		LED1_PORT,LED1_Pin,ACCESS
#define LED1_Output	bcf	LED1_TRIS,LED1_Pin,ACCESS
#define LED1_Set	bsf	Debug_LED1
#define LED1_Clear	bcf	Debug_LED1
#define LED1_Toggle	btg	Debug_LED1
	#else
#define LED1_Output	nop
#define LED1_Set	nop
#define LED1_Clear	nop
#define LED1_Toggle	nop
	#endif


FactoryDefaultsValue	macro	;     
;#else ;       - , , 
;    EPROM\EPROM_Data.inc
;  PCPWM_3F\Parameters_PSW_12b.xls/Param:N4:N35
  db 0x06 ;   0-15=PCPWM_MotorNum
  db 0x5 ;4  =LCD_DebounceTimeOut
;	db	d'53';0x22;09 LCD_6_4	;    4   6
  db d'1';0x53 ;  4 =LCD_6_4

;  09/06/2020       
  db 0x70; PCPWM_SpdMin;  )     
  db 0x28; PCPWM_SpdDelta )       
  db 0x81; PCPWM_K_Prop	  )    
  db 0x82; PCPWM_K_Integr )    
  db 0x83; PCPWM_K_Diff	  )    
  db 0x10; PCPWM_Alrm_Tim )      
  db 0x00; Adc_Corr+5;	  ) AN   
  db 0x26; Adc_Corr+4;	  ) AN   

  db 0x80; 0x05 ;    =Adc_Corr+3
  db d'12' ;  =Adc_Corr+2
  db d'13';0x09 ;   =Adc_Corr+1
  db d'41';-d'9' ;0xAB ; -085  =Adc_Corr+0
  db 0xC9 ;  =Par_V
  db 0x10 ; 1D ; Par_VS; 10=  /
  db 0xA6 ;   =Par_T
	#ifdef	W1_Pin
  db 0x70 ; W1 Temp=Par_K
  db 0x65 ; W1 temp1=Par_K1
	#endif ;#ifdef	W1_Pin

  db 0x10 ;  DC =PcDC_Kf
 ; db 0x8A ;   DC =PcDC_VN

  db 0x0A ;     =PcPwmTopDT
  db 0x08 ; DTCON 0-63  =DTCON
  db 0x01 ; Delay Curiosity=DelayCuriosityIndex
;    
;#endif ;#ifdef PCPWM_Board ;       

;    0   
  db 0x07 ;  =PCPWM_Speed
  db 0xbb ; V/F Amp=PCPWM_Amp
  db 0x46 ; V/F Start=PCPWM_VFStart
  db 0x27 ; Accelerate=PCPWM_Accelerate
  db 0x48 ; =Par_A
  db 0x00 ;   =PCPWM_MaxSpdIndx
  db 0x0A ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x75 ;   -127:127=PCPWM_AutoStart
  db 0x01 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x20 ;    1=PCPWM_Speed_M0
  db 0x30 ;    2=PCPWM_Speed_M1
;;      :
;;	db	d'00';0x10;10 PCPWM_MaxSpdIndx; 0=100  ,      .
;;	db	0xBB;01 PCPWM_Amp
;;	db	0x46;02 PCPWM_VFStart
;;	db	0x1;07 DelayCuriosityIndex
;;	db	0x27;03 PCPWM_Accelerate    .
;;   07 Over Current = 78 -     /  
;;        - .

;;;      400  2.2  220  :
;;	db	d'03';0x10;10 PCPWM_MaxSpdIndx; 3=800  ,   400 .
;;	db	0x93;01 PCPWM_Amp -  ,      18-24
;;	db	0x06;02 PCPWM_VFStart -   -     .
;;	db	0x1;07 DelayCuriosityIndex
;;	db	0xFF;03 PCPWM_Accelerate    .
;;;   07 Over Current = F8;

;    1   
;     - 1.5  4  220/380  .
;  ~30 ,  ~ 3 .
  db 0xFF ;  =PCPWM_Speed
  db 0x80 ; V/F Amp=PCPWM_Amp
  db 0x54 ; V/F Start=PCPWM_VFStart
  db 0xFF ; Accelerate=PCPWM_Accelerate
  db 0x0E ; =Par_A
  db 0x04 ;   =PCPWM_MaxSpdIndx
  db 0x00 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x00 ;   -127:127=PCPWM_AutoStart
  db 0x01 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x80 ;    1=PCPWM_Speed_M0
  db 0x40 ;    2=PCPWM_Speed_M1


;    2   
;;;   450  2.2  220  :
;;	db	d'106';=450  PCPWM_MaxSpdIndx; 106.=0x6A=450  ,   225 .
;;	db	0xB3;01 PCPWM_Amp -  ,      18-24
;;	db	0x0A;02 PCPWM_VFStart -   -     .
;;	db	0x1;07 DelayCuriosityIndex
;;	db	0xFF;03 PCPWM_Accelerate    .
;;;   07 Over Current = 0x50; 

  db 0x55 ;  CPWM_Speed
  db 0xB3 ; V/F Amp=PCPWM_Amp
  db 0x0A ; V/F Start=PCPWM_VFStart
  db 0xF2 ; Accelerate=PCPWM_Accelerate
  db 0x52 ; =Par_A
  db 0x6A ;   =PCPWM_MaxSpdIndx
  db 0x0A ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x40 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x52 ;    1=PCPWM_Speed_M0
  db 0xA2 ;    2=PCPWM_Speed_M1


;    3   
;;;     1.5  4  220  ,      : 
;;	db	0x10;=70 ; d'00';04 PCPWM_MaxSpdIndx; 0=100  ,      .
;;	db	0xB0;05 PCPWM_Amp
;;	db	0x27;06 PCPWM_VFStart
;;	db	0x1;07 DelayCuriosityIndex
;;	db	0x40;08 PCPWM_Accelerate    .
;;;    4  1.5  


  db 0x33 ;  =PCPWM_Speed
  db 0xB0 ; V/F Amp=PCPWM_Amp
  db 0x27 ; V/F Start=PCPWM_VFStart
  db 0x93 ; Accelerate=PCPWM_Accelerate
  db 0x53 ; =Par_A
  db 0x10 ;   =PCPWM_MaxSpdIndx
  db 0x00 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x99 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x77 ;    1=PCPWM_Speed_M0
  db 0xAA ;    2=PCPWM_Speed_M1


;    4   
;;;     -1025 250  200  36  2    30  DC
;;	db	d'106';=450 ; ;04 PCPWM_MaxSpdIndx; 0=100  ,      .
;;	db	0xB0;05 PCPWM_Amp
;;	db	0x27;06 PCPWM_VFStart
;;	db	0x1;07 DelayCuriosityIndex
;;	db	0xFF;08 PCPWM_Accelerate    .

  db 0x44 ;  =PCPWM_Speed
  db 0xB0 ; V/F Amp=PCPWM_Amp
  db 0x27 ; V/F Start=PCPWM_VFStart
  db 0xF4 ; Accelerate=PCPWM_Accelerate
  db 0x54 ; =Par_A
  db 0x6A ; = ~400 Hz   =PCPWM_MaxSpdIndx
  db 0x0B ; = ~6 KHz   0-20=PcPwmFrqInd 
  db 0x03 ; =1/3 Rev    0-3=PcPwmAngInd
  db 0x04 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x0A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x77 ;    1=PCPWM_Speed_M0
  db 0xBB ;    2=PCPWM_Speed_M1

;    5   
;  -6   4100L43 4  4  50  
;   3    ,   
  db 0xFF ;  =PCPWM_Speed
  db 0x8B ; V/F Amp=PCPWM_Amp
  db 0x43 ; V/F Start=PCPWM_VFStart
  db 0x81 ; Accelerate=PCPWM_Accelerate
  db 0x77 ; =Par_A
  db 0x0C ; = ~ 65 Hz   =PCPWM_MaxSpdIndx
  db 0x00 ; = ~ 1.5 KHz   0-20=PcPwmFrqInd
  db 0x03 ; = 1/3 Rev    0-3=PcPwmAngInd
  db d'200';   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0xA2 ;   DC =PcDC_VN
  db 0x87 ; 60 ;   (  )=Par_UV ;    
  db 0x88 ;    5  1=PCPWM_Speed_M0
  db 0xAA ;    8  2=PCPWM_Speed_M1

;    6   
;"3Kw 75Hz -1 "	,0;6
  db 0x66 ;  =PCPWM_Speed
  db 0x8D ; V/F Amp=PCPWM_Amp
  db 0x3F ; V/F Start=PCPWM_VFStart
  db 0x5D ; Accelerate=PCPWM_Accelerate
  db 0x81 ; =Par_A
  db 0x0B ; ~ 75 Hz   =PCPWM_MaxSpdIndx
  db 0x00 ; ~ 1.5 KHz   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0xC0 ;   -127:127=PCPWM_AutoStart
  db 0x02 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x8E ; 60 ;   (  )=Par_UV ;    
  db 0x66 ;    1=PCPWM_Speed_M0
  db 0xBB ;    2=PCPWM_Speed_M1

;    7   
  db 0x07 ;  =PCPWM_Speed
  db 0x07 ; V/F Amp=PCPWM_Amp
  db 0x07 ; V/F Start=PCPWM_VFStart
  db 0xF7 ; Accelerate=PCPWM_Accelerate
  db 0x57 ; =Par_A
  db 0x00 ;   =PCPWM_MaxSpdIndx
  db 0x07 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x07 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x2A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x07 ;    1=PCPWM_Speed_M0
  db 0x07 ;    2=PCPWM_Speed_M1

;    8   
  db 0x08 ;  =PCPWM_Speed
  db 0x08 ; V/F Amp=PCPWM_Amp
  db 0x08 ; V/F Start=PCPWM_VFStart
  db 0xF8 ; Accelerate=PCPWM_Accelerate
  db 0x58 ; =Par_A
  db 0x00 ;   =PCPWM_MaxSpdIndx
  db 0x08 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x08 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x2A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x08 ;    1=PCPWM_Speed_M0
  db 0x08 ;    2=PCPWM_Speed_M1

;    9   
  db 0x09 ;  =PCPWM_Speed
  db 0x09 ; V/F Amp=PCPWM_Amp
  db 0x09 ; V/F Start=PCPWM_VFStart
  db 0xF9 ; Accelerate=PCPWM_Accelerate
  db 0x59 ; =Par_A
  db 0x00 ;   =PCPWM_MaxSpdIndx
  db 0x09 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x09 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x09 ;    1=PCPWM_Speed_M0
  db 0x09 ;    2=PCPWM_Speed_M1

;    10   
  db 0x10 ;  =PCPWM_Speed
  db 0x10 ; V/F Amp=PCPWM_Amp
  db 0x10 ; V/F Start=PCPWM_VFStart
  db 0xE0 ; Accelerate=PCPWM_Accelerate
  db 0x60 ; =Par_A
  db 0x00 ;   =PCPWM_MaxSpdIndx
  db 0x0A ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x10 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x10 ;    1=PCPWM_Speed_M0
  db 0x10 ;    2=PCPWM_Speed_M1

;    11   
  db 0x11 ;  =PCPWM_Speed
  db 0x11 ; V/F Amp=PCPWM_Amp
  db 0x11 ; V/F Start=PCPWM_VFStart
  db 0xE1 ; Accelerate=PCPWM_Accelerate
  db 0x61 ; =Par_A
  db 0x00 ;   =PCPWM_MaxSpdIndx
  db 0x0B ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x11 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x8A ;   DC =PcDC_VN
  db 0x70 ; 60 ;   (  )=Par_UV ;    
  db 0x11 ;    1=PCPWM_Speed_M0
  db 0x11 ;    2=PCPWM_Speed_M1

;    12   
; 02/11/2021 - -82012 3*36V 1065W 20A 48.6 c-1 1986 .
  db 0x17 ;  =PCPWM_Speed
  db 0x82 ; V/F Amp=PCPWM_Amp
  db 0x70 ; V/F Start=PCPWM_VFStart
  db 0xFF ; Accelerate=PCPWM_Accelerate
  db 0x99 ; =Par_A
  db 0x08 ;   =PCPWM_MaxSpdIndx
  db 0x05 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x21 ;   -127:127=PCPWM_AutoStart
  db 0x02 ;    =PcPwmProg
  db 0x14 ;   DC =PcDC_VN
  db 0x07 ; 60 ;   (  )=Par_UV ;    
  db 0x33 ;    1=PCPWM_Speed_M0
  db 0x55 ;    2=PCPWM_Speed_M1

;    13 -  HDD  15  
  db 0x02 ;  =PCPWM_Speed
  db 0x3C ; V/F Amp=PCPWM_Amp
  db 0x6F ; V/F Start=PCPWM_VFStart
  db 0xFF ; Accelerate=PCPWM_Accelerate
  db 0x0B ; =Par_A
  db 0x01 ;   =PCPWM_MaxSpdIndx
  db 0x0E ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x08 ;   -127:127=PCPWM_AutoStart
  db 0x00 ;    =PcPwmProg
  db 0x06 ;   DC =PcDC_VN
  db 0x05 ; 60 ;   (  )=Par_UV ;    
  db 0x23 ;    1=PCPWM_Speed_M0
  db 0x83 ;    2=PCPWM_Speed_M1

;   14  - -1025    0-30  
  db 0x63 ;  =PCPWM_Speed
  db 0x9D ; V/F Amp=PCPWM_Amp
  db 0x35 ; V/F Start=PCPWM_VFStart
  db 0xFF ; Accelerate=PCPWM_Accelerate
  db 0x2A ; =Par_A
  db 0x24 ;   =PCPWM_MaxSpdIndx
  db 0x09 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x04 ;   -127:127=PCPWM_AutoStart
  db 0x01 ;    =PcPwmProg
  db 0x10 ;   DC =PcDC_VN
  db 0x07 ; 60 ;   (  )=Par_UV ;    
  db 0x28 ;    1=PCPWM_Speed_M0
  db 0x14 ;    2=PCPWM_Speed_M1

;    15  __dbbug
; 02/11/2021 - -82012 3*36V 1065W 20A 48.6 c-1 1986 .
  db 0x05 ;  =PCPWM_Speed
  db 0xEE ; V/F Amp=PCPWM_Amp
  db 0xE6 ; V/F Start=PCPWM_VFStart
  db 0x33 ; Accelerate=PCPWM_Accelerate
  db 0x99 ; =Par_A
  db 0x04 ;   =PCPWM_MaxSpdIndx
  db 0x00 ;   0-20=PcPwmFrqInd
  db 0x03 ;    0-3=PcPwmAngInd
  db 0x03 ;   -127:127=PCPWM_AutoStart
  db 0x01 ;    =PcPwmProg
  db 0x15 ;   DC =PcDC_VN
  db 0x07 ; 60 ;   (  )=Par_UV ;    
  db 0x88 ;    1=PCPWM_Speed_M0
  db 0x66 ;    2=PCPWM_Speed_M1

	endm

;CfgMotorName	macro	;     
;      
;   LCD_SubStr.inc ~658
;	endm

 #define LCD_Present	Proj_Dir\Cfg\Lcd_Drv2431_2.inc	;YES	;    
 #include Proj_Dir\Cfg\Lcd_Def2431_2.inc	;      .
