;******************************************
;    Filename: RealTimeKeep.Asm           *
;    Date:                                *
;    File Version: 000.001                *
;    Author: PSW.RU                       *
;    Company: Labs                        *
	#include Define.h	;     
	global	TK_10,TK_100,TK_1000	;   .
	;Extern	InitAll,HighInt


;******************************************
TimeKeeping	code	
TK_1000	;	
;*******************************************
; 1000    
;   MainLoop
;*******************************************
		retlw	0x0 ; 
TK_100	;	
;*******************************************
; 100    
;   MainLoop
;*******************************************
		retlw	0x0 ; 
TK_10	;	
;*******************************************
; 10    
;   MainLoop
;*******************************************
 #ifdef LCD_Present
  #ifdef	PCPWM_Present
	#include Proj_Dir\PCPWM_3F\DiagString.inc; 06/11/2021   
  #endif;	#ifdef	PCPWM_Present

	movlw	d'6'	;;  6  10   .
 btfsc	LCD_Flg1,3,ACCESS		;  / 

;  incf	WREG,W,ACCESS		;  6   7   
; 04/11/2021    
	movff	LcdWorkNum,WREG		;   

 LcdOutStr 0x1	;   = 10   

 btfsc	LCD_Flg1,3,ACCESS		;  / 
	bra	EncoderNotPrint	;       
;    ParametrNum 10    
	movf	Encoder_Count,W,ACCESS	;  
	addlw	ParamDelta	;     
 LcdOutStr	0x2	;   
EncoderNotPrint
 #endif	; #ifdef LCD_Present

 #ifdef LCD_Work_Present
	btfss	LCD_Flg1,3,ACCESS	;  / 
		bra		Cont1			;    
	btfsc	Key_Encoder ;PortB_Buf,5,ACCESS	;    = 0 ?
		clrf	LcdWorkTime,ACCESS		; - -    
;	bra		DoneButt		;   
Cont1
 #endif	; #ifdef LCD_Work_Present


 #ifdef	PCPWM_Present
;     
;	#include Proj_Dir\PCPWM_3F\DiagString.inc; 06/11/2021   
 #endif ;#ifdef	PCPWM_Present

; 1      , 10  - .

	INCF 	Tic_10, F,ACCESS ; Increment tics 1/10 s

 #ifdef LCD_Work_Present
;   -    -    ?
;      - -  
	MOVLW .9 ;    9     
	subwf	Tic_10,W,ACCESS ;
	btfsc	_Z
;		bra ClearLcdDone		; 9    
	btfsc	LCD_Flg1,3,ACCESS	;  / 
		bra		ClrLcdDone
  clrf		LCD_Flg,ACCESS		;   		;
;btfss	LCD_Flg1,3,ACCESS	;  / 
  clrf		LCD_Flg2,ACCESS		;    

ClrLcdDone

 #endif	; #ifdef LCD_Work_Present


	MOVLW .9 ; 10 ticss elapsed?
	CPFSGT Tic_10	; (f) - (WREG) skip if (f) > (WREG); (unsigned comparison)
;TicsLcdWrite
		return	;bra		Tmr0ExitCheck
			
;*******************************************
; 1    
;*******************************************
 
;	movff Keyb_Freq_Count, Keyb_Freq_Out	;  
;	clrf	WREG,ACCESS						;  
;	movff WREG,Keyb_Freq_Count				;   	 

; LED0_Toggle	;   

 Beeper_TrisTogl ;  3   
; Beeper_Toggle	;  3   

 	bsf	 LCD_Flg1,6,ACCESS	;;6=   1   

 #ifdef	DelayCuriosityTest	; 07/03/2020   
 	#ifdef ADC_Present
	ADC_Page	; BSR for ADC Task
 bcf		INTCON,GIEH,ACCESS		;   
 movff24	ADC_Cnt_All,ADC_Print ; -  
	clrf	ADC_Cnt_All,BANKED
	clrf	ADC_Cnt_All+1,BANKED	;    -    
	clrf	ADC_Cnt_All+2,BANKED	;
 bsf		INTCON,GIEH,ACCESS		;   	
	RTK_Page	; BSR for RTK Task
 	#endif	; #ifdef ADC_Present
 #endif ;#ifdef	DelayCuriosityTest	; 07/03/2020   

#ifdef PCPWM_Present	;  
	PCPWM_Page	; BSR for PCPWM Task
 bcf		INTCON,GIEH,ACCESS		;   
 movff16	PCPWM_SpdCount,PCPWM_SpdBuf;Print ; -  
	clrf	PCPWM_SpdCount,BANKED
	clrf	PCPWM_SpdCount+1,BANKED	;
 bsf		INTCON,GIEH,ACCESS		;   	
;	Print_Page; BSR  0   

; 0xff=364 , 0xBD=200 0x86=100/101 0x5F=50/51 0x43=25 0x2F=12 0x20=6
;
; 0xD5=15240 
;   16     8  
	
	movf	PCPWM_SpdBuf,W,BANKED	;   16  
	mullw	d'60'	;   60 

	movff16	PRODL,PCPWM_ML_Work	;  
;	clrf	SynMulBuf+2,BANKED	;     
;	clrf	SynMulBuf+3,BANKED	;    0
	
	movf	PCPWM_SpdBuf+1,W,BANKED	;   16  
	mullw	d'60'	;   60 

	MOVF	PRODL,W,ACCESS;	;  16  
	ADDWF	PCPWM_ML_Work+1,F,BANKED;  8*8
;  , ,  .
;	MOVF	PRODH,W,ACCESS	;   32 		;
;	ADDWFC	SynMulBuf+2,F,BANKED;   1 	;
;	CLRF	WREG,ACCESS;	; ADD16 Macro				;
;	ADDWFC	SynMulBuf+3,F,BANKED;						;

 movff16	PCPWM_ML_Work,PCPWM_SpdPrint ; -  
; movff16	PCPWM_SpdBuf,PCPWM_SpdPrint ; -  
	RTK_Page	; BSR for RTK Task
 #endif	;#ifdef PCPWM_Present	;  

 ;btg		PIE3,PTIE,ACCESS		;  PCPWM 
 #ifdef LCD_Work_Present
	btfsc	Flag1,0,ACCESS		;  / 
		clrf LcdWorkTime,ACCESS	; -    
	incf	LcdWorkTime,F,ACCESS	; - ,    

	btfsc	LCD_Flg1,3,ACCESS		;  / 
		bra DoneLcdWork	
	;incf	LcdWorkTime,F,ACCESS	; - 
	MOVLW LCD_TimeOut_Work ; 20 seconds elapsed for WORK display ?	
	;CPFSLT	LcdWorkTime,ACCESS	; (f) - (WREG) skip if (f) < (WREG); (unsigned comparison)
	;bsf		LCD_Flg1,3,ACCESS		;  / 
		bra DoneLcdWork1	
DoneLcdWork
	;incf	LcdWorkTime,F,ACCESS	; - 
	MOVLW LCD_TimeOut_Service ; 5 seconds elapsed for PRESS ENCODER KEY  ?	
	;CPFSLT	LcdWorkTime,ACCESS	; (f) - (WREG) skip if (f) < (WREG); (unsigned comparison)
	;bcf		LCD_Flg1,3,ACCESS		;  / 
DoneLcdWork1
	CPFSGT	LcdWorkTime,ACCESS	; (f) - (WREG) skip if (f) < (WREG); (unsigned comparison)
		bra DoneLcdWork2	
	btg		LCD_Flg1,3,ACCESS		;  / 
	;CPFSLT	LcdWorkTime,ACCESS	; (f) - (WREG) skip if (f) < (WREG); (unsigned comparison)
	clrf		LcdWorkTime,ACCESS	;     
	clrf		LCD_Flg,ACCESS		;    -   
	clrf		LCD_Flg2,ACCESS		;    -   

DoneLcdWork2
 #endif	; #ifdef LCD_Work_Present

	CLRF Tic_10,ACCESS ; Clear tics
	INCF secs, F,ACCESS ; Increment seconds
	INCF 	SecsCounter, F,ACCESS ;     

;LED0_Toggle
;Beeper 0x1	;  500 
	;INCF secs,ACCESS ; Increment seconds twice
	MOVLW .59 ; 60 seconds elapsed?	
	CPFSGT secs,ACCESS	; (f) - (WREG) skip if (f) > (WREG); (unsigned comparison)
			bra		Tmr0ExitCheck
;*******************************************
; 1    
;*******************************************
; Beeper 0xF;  500 ,   


 #ifdef LCD_Work_Present
;   -    -    ?
;      - -  
	btfsc	LCD_Flg1,3,ACCESS	;  / 
  clrf		LCD_Flg,ACCESS		;   		
	btfsc	LCD_Flg1,3,ACCESS	;  / 
  clrf		LCD_Flg2,ACCESS		;    
 #endif	; #ifdef LCD_Work_Present
 
	CLRF secs,ACCESS ; Clear seconds
	INCF mins, F,ACCESS ; Increment minutes
	;INCF MinsCounter, F,ACCESS ; Increment minutes
	MOVLW .59 ; 60 minutes elapsed?
	CPFSGT mins,ACCESS	; (f) - (WREG) skip if (f) > (WREG); (unsigned comparison)
			bra		Tmr0ExitCheck
;*******************************************
; 1    
;*******************************************
	CLRF mins,ACCESS ; clear minutes
 ;Beeper 0xE1	;  500 ,     
	INCF hours, F,ACCESS ; Increment hours
	;INCF HourCounter, F,ACCESS ; Increment hours
	MOVLW .23 ; 24 hours elapsed?
	CPFSGT hours,ACCESS	; (f) - (WREG) skip if (f) > (WREG); (unsigned comparison)
			bra		Tmr0ExitCheck
;*******************************************
; 1    
;*******************************************
	;MOVLW .0 ; Reset hours to 1
	clrf hours,ACCESS
	INCF days, F,ACCESS ; Increment hours
	MOVLW .99 ; 99 days elapsed?
	CPFSGT days,ACCESS	; (f) - (WREG) skip if (f) > (WREG); (unsigned comparison)
			bra		Tmr0ExitCheck
	clrf days,ACCESS
;			bra		Tmr0ExitCheck
Tmr0ExitCheck

;  1   :
 	movlw	d'3' ;     
 LcdOutStr	0x0	;   = 1   
 
 
; #ifdef LCD_Present
;	btfss	LCD_Flg,4,ACCESS	;   LCD   
;		return	;bra		Tmr0ExitCheck
;;  1   :
;	clrf	LCD_Pos,ACCESS	;     
;	movlf	d'3',LCD_Com,ACCESS	;  3  1   .
;	clrf	LCD_Com+1,ACCESS		;    / .
;	bcf		LCD_Flg,4,ACCESS		;   
;;	RTK_Page	; BSR for RTK Task
; #endif
		retlw	0x0 ; 
;		return	; bra		Tmr0ExitCheck

; #endif; #ifdef LCD_Present
;End of program
		END

